/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package exenne.components.swingworkers.progressworker;

import exenne.components.modalpanel.progresspanel.JProgressPanel;
import exenne.components.utils.RandomDataGenerator;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

/**
 *
 * @author iulian
 */
public class JProgressWorkerTest {
    /**~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     *     Test area
     *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
    private static final AbstractProgressCallable<Integer> mainCallable =
            new AbstractProgressCallable<Integer>() {
        public Integer call() throws Exception {
            Integer integer = RandomDataGenerator.getRandomInt(10);


            //Fac iteratiile mele
            this.setProgressRange(0, 50);
            int iterations = 10;
            for (int i = 0; i < iterations; i++) {
                this.setProgressInfo("main_"+i);

                int progress = ((i+1) * 100) / iterations;
                this.setProgressValue(progress);
                Thread.sleep(500);
            }

            //Fac iteratiile copii
            this.setProgressRange(50, 100);
            secondaryCallable.setProgressInfoManager(this);
            secondaryCallable.call();

            //Intorc rezultatul
            return integer;
        }
    };

    private static final AbstractProgressCallable<Integer> secondaryCallable =
            new AbstractProgressCallable<Integer>() {
        public Integer call() throws Exception {
            Integer integer = RandomDataGenerator.getRandomInt(10);

            int iterations = 5;
            for (int i = 0; i < iterations; i++) {
                this.setProgressInfo("secondary_"+i);

                int progress = ((i+1) * 100) / iterations;
                this.setProgressValue(progress);
                Thread.sleep(500);
                
                this.addErrorMessage("dubious error");
                throw new Exception("ole");
            }



            //Intorc rezultatul
            return integer;
        }
    };


    /**
     * Metoda main de test
     * @param args
     */
    public static void main(String[] args) {
        final JFrame frame = new JFrame("Test");
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        JButton button = new JButton("Do bg action");
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            //Umplu raportul in background pentru a afisa un panou modal de incarcare
            JProgressSwingWorker fillWorker =
                    new JProgressSwingWorker(frame, "Computing",mainCallable, JProgressPanel.DETERMINATE);
            //fillWorker.setStandardErrorMessage("Eroare la rulare");

            //Obtin elementul de tiparit
            Integer integer = (Integer)
                    fillWorker.executeTask();
            System.out.println("Got result "+integer);
            }
        });
        frame.add(button);
        frame.pack();

        //Afisez
        frame.setVisible(true);
    }
}
